/*===============================================================*
 *
 *===============================================================*/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

static const char __PROGRAM_VERSION__[] = "@(#)dat2c.c Ver. 0.0003 (2021/12/28 18:14:42)";

/*---------------------------------------------------------------*
 *
 *---------------------------------------------------------------*/
char *
gettok(char *s, char *token)
{
    char    *p;

    if (s == NULL || *s == '\0')
        return NULL;

    while (isspace(*s)) {
        s++;
    }

    *token = '\0';
    for (p = token; *s && !isspace(*s); s++) {
        *p++ = *s;
    }
    *p = '\0';
    return s;
}

/*---------------------------------------------------------------*
 *
 *---------------------------------------------------------------*/
char *
strip_space(char *s)
{
    char    *p;
    int     n;

    if ((p = strchr(s, '\r')) != NULL) {
        *p = '\0';
    }

    for (p = s + strlen(s) - 1; isspace(*p); p--) {
        *p = '\0';
    }

    for (p = s; isspace(*p); p++) {
        ;
    }

    return  p;
}

/*---------------------------------------------------------------*
 *
 *---------------------------------------------------------------*/
void
strip_comment(char *s)
{
    char    *p;

    if ((p = strchr(s, '#')) != NULL) {
        *p = '\0';
    }
    if ((p = strchr(s, '/')) != NULL && *(p+1) == '/') {
        *p = '\0';
    }
}

/*---------------------------------------------------------------*
 *
 *---------------------------------------------------------------*/
void
del_comma(char *s)
{
    char    *p;

    while ((p = strchr(s, ',')) != NULL) {
        *p = ' ';
    }
}

/*---------------------------------------------------------------*
 *
 *---------------------------------------------------------------*/
int
main(int ac, char *av[])
{
    FILE    *fp;
    char    *fname;
    char    buf[BUFSIZ], *p;
    char    token1[BUFSIZ], token2[BUFSIZ];
    int     ini2dat_flag = 0;

    if (ac == 1) {
        printf("usage: %s [-i] .dat\n", av[0]);
        return  0;
    }
    if (ac == 2) {
        fname = av[1];
    }
    if (ac >= 3) {
        if (strcmp(av[1], "-i") == 0) {
            ini2dat_flag = 1;
        }
        fname = av[2];
    }

    if ((fp = fopen(fname, "r")) == NULL) {
        fprintf(stderr, "can't open %s\n", fname);
        return  1;
    }

    while (fgets(buf, BUFSIZ, fp) != NULL) {
        strip_comment(buf);
        p = strip_space(buf);
        if (strlen(p)) {
            if (*p == '0') { // 0x
                del_comma(p);
                p = gettok(p, token1);
                if (p != NULL) {
                    p = gettok(p, token2);
                }
                if (p != NULL) {
                    if (ini2dat_flag == 0) {
                        printf("    {%s, %s},\n", token1, token2);
                    } else {
                        printf("%s %s\n", token1, token2);
                    }
                } else {
                    printf("NULL:%s\n", buf);
                }
            } else {
                printf("// %s\n", buf);
            }
        }
    }

    fclose(fp);

    return  0;
}
